<script lang="ts">
import { onMount } from "svelte";

export let imgSrc: string;
export let altText = "";

let scrollElement: HTMLElement;
let observer: IntersectionObserver;

onMount(() => {
  observer = new IntersectionObserver(([entry]) => {
    if (entry.isIntersecting) {
      observer.disconnect();
      setTimeout(() => { scrollElement.style.setProperty("opacity", "50%") }, 300);

      scrollElement.addEventListener("mouseover", () => {
        scrollElement.style.setProperty("opacity", "100%");
        scrollElement.style.setProperty("filter", "grayscale(0%)");
      });
      
      scrollElement.addEventListener("mouseout", () => {
        scrollElement.style.setProperty("opacity", "50%");
        scrollElement.style.setProperty("filter", "grayscale(100%)");
      });
    }
  });
  observer.observe(scrollElement);
});
</script>

<img bind:this={scrollElement} src="{imgSrc}" alt="{altText}" />
<style>
  img {
    height: calc(5vw + 2rem);
    opacity: 0%;
		filter: grayscale(100%);
    transition-property: filter, opacity;
    transition-duration: 0.2s;
  }
  @media (max-width: 1200px) {
    img {
      height: calc(4vw + 2rem);
    }
  }
</style>
